﻿using System;
using PSO2SERVER.Models;
using PSO2SERVER.Protocol.Packets;

namespace PSO2SERVER.Protocol.Handlers
{
    [PacketHandlerAttr(0x0E, 0x28)]
    public class PlayerIsBusyState : PacketHandler
    {
        public override void HandlePacket(Client context, byte flags, byte[] data, uint position, uint size)
        {
            if (context.Character == null)
                return;
            //var info = string.Format("[<--] 接收到的数据 (hex): {0} 字节", data.Length);
            //Logger.WriteHex(info, data);
            foreach (var c in Server.Instance.Clients)
            {
                if (c.Character == null || c.CurrentMap != context.CurrentMap)
                    continue;

                c.SendPacket(new NewBusyStatePacket(context._account.AccountId, BusyState.Busy));
            }
        }
    }
}
