﻿using PSO2SERVER.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PSO2SERVER.Protocol.Packets
{
    public class CharacterFlagsPacket : Packet
    {

        /// <summary>
        /// Character flags.
        /// </summary>
        public FixedList<byte> Flags { get; set; } = new FixedList<byte>(0xC00, 0);

        /// <summary>
        /// Character parameters.
        /// </summary>
        public FixedList<uint> Params { get; set; } = new FixedList<uint>(0x100, 0);

        public CharacterFlagsPacket()
        {
        }

        public CharacterFlagsPacket(FixedList<byte> Flags, FixedList<uint> Params)
        {
            this.Flags = Flags;
            this.Params = Params;
        }

        #region implemented abstract members of Packet

        public override byte[] Build()
        {
            var pkt = new PacketWriter();
            pkt.WriteList(Flags);
            pkt.WriteList(Params);
            return pkt.ToArray();
        }

        public override PacketHeader GetHeader()
        {
            return new PacketHeader(0x23, 0x07, PacketFlags.None);
        }

        #endregion
    }
}